<?php

/*
Plugin Name: SABRE
Plugin URI: http://didier.lorphelin.free.fr/blog/index.php/wordpress/sabre/
Description: Simple Anti Bot Registration Engine
Version: 0.7.4
Author: Didier Lorphelin
Author URI: http://didier.lorphelin.free.fr
*/

/***********************************************************************/
/* Initialization                                                      */
/***********************************************************************/

function sabre_init() {

	if (!function_exists('wp_print_styles')) {
		// before WP 2.6
		load_plugin_textdomain('sabre', PLUGINDIR . '/' . SABREDIR . '/languages');
	} else {
		// WP 2.6
		load_plugin_textdomain('sabre', false, SABREDIR . '/languages');
	}	
}

/***********************************************************************/
/* Add Sabre page in the Admin/Manage menu                             */
/***********************************************************************/

function sabre_options() {

	add_management_page(__('Sabre Options', 'sabre'), 'Sabre', 8, "sabre", 'sabre_option_page');
}

/***********************************************************************/
/* Handling of Sabre in the Admin/Manage menu                          */
/***********************************************************************/

function sabre_option_page() {

	require_once(SABREPATH . 'sabre_admin.php');

}

/***********************************************************************/
/* Add tests to registration form                                      */
/***********************************************************************/

function sabre_change_registration_form() {
	global $wpdb;

	$sabre = get_option('sabre_captcha');
	extract ($sabre, EXTR_OVERWRITE) ;
	$sabre = get_option('sabre_math');
	extract ($sabre, EXTR_OVERWRITE) ;
	$sabre_seq = get_option('sabre_seq');
	$sabre = get_option('sabre_stealth');
	extract ($sabre, EXTR_OVERWRITE) ;
	$sabre = get_option('sabre_opt');
	extract ($sabre, EXTR_OVERWRITE) ;


	// Choose the sequence of tests
	if ($sabre_seq == 'Random') {
		$dice = mt_rand(1,2);
		switch ($dice) {
			case 1 :
				$enable_math = 'false';
				$enable_captcha = 'true';
				break;
			case 2 :
				$enable_math = 'true';
				$enable_captcha = 'false';
				break;
		}
	}

	if ($enable_captcha == 'true') {
		$max = strlen($acceptedChars)-1;
		for($i=0; $i < $stringlength; $i++)
			$password .= $acceptedChars{mt_rand(0, $max)};
	}
	if ($enable_math == 'true') {
		$max = strlen($math_ops)-1;
		$mathop = $math_ops{mt_rand(0, $max)};
		$nb1 = mt_rand(1, 20);
		$nb2 = mt_rand(1, 20);
		switch ($mathop) {
			case '-' :
				if ($nb1 > $nb2) {
					$mathcode = $nb1 - $nb2;
					$mathstring = $nb1 . ' - ' . $nb2;
					}
				else {
					$mathcode = $nb2 - $nb1;
					$mathstring = $nb2 . ' - ' . $nb1;
					}
				break;
			case '*' :
				$mathcode = $nb1 * $nb2;
				$mathstring = $nb1 . ' * ' . $nb2;
				break;
			case '+' :
			default  :
				$mathcode = $nb1 + $nb2;
				$mathstring = $nb1 . ' + ' . $nb2;
				break;
			}
	}

	$curdate = time();
	@$wpdb->query("INSERT INTO `" . SABRE_TABLE . "` SET `user_IP` = '" . $_SERVER['REMOTE_ADDR'] . "', `first_mod` = FROM_UNIXTIME($curdate), `last_mod` = FROM_UNIXTIME($curdate)" . (isset($password) ? ", `captcha` = '" . $password . "'" : "") . (isset($mathcode) ? ", `math` = " . $mathcode : ""));
	$id = $wpdb->insert_id;

	if ($user_pwd == 'true') {
		echo '<p>';
		echo '<label>' . __('Please enter your password twice:', 'sabre') . '<br />';
		echo '<input type="password" name="user_pwd1" id="user_pwd1" class="input" value="" size="20" tabindex="25" /></label>';
		echo '<input type="password" name="user_pwd2" id="user_pwd2" class="input" value="" size="20" tabindex="26" /></label><br />';
		echo '<strong>' . __('Password Strength:') . '</strong><br />';
		echo '<label id="pass-strength-result">' . __('Too short') . '</label><br />' . __('Hint: Use upper and lower case characters, numbers and symbols like !"?$%^&amp;( in your password.');
		echo '</p>';
	}
 
	if ($enable_captcha == 'true') {
		echo '<p>';
		echo '<img src="' . SABREURL . 'sabre_captcha.php?sabre_id=' . $id . '" border="0" /><br />';
		echo '<label>' . __('Please enter the code shown above:', 'sabre') . '<br />';
		echo '<input type="text" name="captcha" id="captcha" class="input" value="" size="25" tabindex="30" /></label>';
		echo '</p>';
	}
	if ($enable_math == 'true') {
		echo '<p>';
		echo '<label>' . sprintf(__('Please enter the result: %s', 'sabre'), $mathstring) . '<br />';
		echo '<input type="text" name="math" id="math" class="input" value="" size="10" tabindex="40" /></label>';
		echo '</p>';
	}
	if ($enable_policy == 'true') {
		echo '<p>';
		echo '<label>' . $policy_name . '<br />';
		echo '<textarea rows="10" cols="40" readonly>' . $policy_text . '</textarea></label>';
		echo '<input type="checkbox" name="policy" id="policy" class="input" value="yes" tabindex="45" /></label>';
		_e('I agree', 'sabre');
		echo '</p>';
	}

	// Add anti-bot fields
	if ($enable_stealth == 'true') {
		// Verify fake user
		$fakeField = "X" . md5($id . $magic_seed . $_SERVER['REMOTE_ADDR'] . $curdate);
		echo '<p id="sabre_spectre">';
		echo '<label>' . __("Please don't modify this field:", 'sabre') . '<br />';
		echo "<input type=\"text\" name=\"$fakeField\" id=\"$fakeField\" class=\"input\" value=\"\" size=\"10\" tabindex=\"50\" /></label>";
		echo '</p>';

		// Verify Javascript capabilities
		$max = rand(5, 9);
		$tot = $str = 1;

		for ($i = 0; $i < $max; $i++) {
			$op = rand(0, 8);
			$num = rand(1, 42);

			switch ($op) {
				case 0:
				case 8:
					$str = "(" . $str . " + " . $num . ")";
					$tot += $num;
				break;
				case 1:
					$str = "(" . $str . " - " . $num . ")";
					$tot -= $num;
				break;
				case 2:
					$str = "(" . $str . " * " . $num . ")";
					$tot *= $num;
				break;
				case 3:
					$str = "Math.round ( Math.abs(" . $str . " / " . $num . "))";
					$tot = round(abs($tot / $num));
				break;
				case 4:
					$str = "Math.min(" . $str . ", " . $num . ")";
					$tot = min($tot, $num);
				break;
				case 5:
					$str = "Math.max(" . $str . ", " . $num . ")";
					$tot = max($tot, $num);
				break;
				case 6:
					$str = "Math.round ( Math.abs(" . $str . " % " . $num . "))";
					$tot = round(abs($tot % $num));
				break;
				case 7:
					$str = "(" . $str . " + Math.round( Math.abs(100*Math.sin(" . $num . ")) ) )";
					$tot = $tot + round(abs(100*sin($num)));
				break;
				}
			}

		$js_command = "Math.round ( Math.abs(" . $str . "))" ;
		$tot = round(abs($tot));

		$check1 = sabre_magic_seed(10);
		$check2 = md5($tot . $check1 . $magic_seed);

		echo '<input type="hidden" id="sabre_js_check1" name="sabre_js_check1" value="' . $check1 . '" />';
		echo '<input type="hidden" id="sabre_js_check2" name="sabre_js_check2" value="' . $check2 . '" />';
		echo "\n<script type=\"text/javascript\">";
		echo "\n<!--";
		echo "\ndocument.write('<input type=\"hidden\" id=\"sabre_js_payload\" name=\"sabre_js_payload\" value=\"');";
		echo "\ndocument.write($js_command);";
		echo "\ndocument.write('\" />');";
		echo "\n-->";
		echo "\n</script>";
	}

	echo '<input type="hidden" name="sabre_id" id="sabre_id" class="input" value="' . $id . '" />';

	// Add Sabre banner
	if ($show_banner == 'true')
		echo '<p>' . __('Protected by', 'sabre') . ' <a id="sabre_link" href="http://didier.lorphelin.free.fr/blog/index.php/wordpress/sabre">Sabre</a>.' . ($total_stopped ? sprintf(__(' %s aliens stopped.', 'sabre'), $total_stopped) : '') . '</p>';
}


/***********************************************************************/
/* Test the info entered by the user                                   */
/***********************************************************************/

function sabre_check_entry($errors) {
	global $wpdb;

	// To speed up things, check the user entry only if no error was detected before calling Sabre

if ( $errors->get_error_code() == '') {

	$sabre_captcha = get_option('sabre_captcha');
	$sabre_math = get_option('sabre_math');
	$sabre_confirm = get_option('sabre_confirm');
	$sabre_stealth = get_option('sabre_stealth');
	$sabre_opt = get_option('sabre_opt');

	$sabre_errors = array();
	$error_head_text = __('<strong>ERROR</strong>: ', 'sabre');

	$result = $wpdb->get_row("SELECT * FROM `" . SABRE_TABLE . "` WHERE `id` = " . (int)$_POST['sabre_id']);

	if (empty($result->id)) {
		$error_msg_text = __('Unknown session.', 'sabre');
		$errors->add('sabre_session', $error_head_text . $error_msg_text);
		$sabre_errors['sabre_session'] = $error_msg_text;
		}

	if ($result->status != 'pending') {
		$error_msg_text = __('Invalid session status.', 'sabre');
		$errors->add('sabre_session_status', $error_head_text . $error_msg_text);
		$sabre_errors['sabre_session_status'] = $error_msg_text;
		}

	if ($sabre_stealth['enable_stealth'] == 'true') {
		// Check user IP
		if ($result->user_IP <> $_SERVER['REMOTE_ADDR']) {
			$error_msg_text = __('Invalid IP address.', 'sabre');
			$errors->add('sabre_IP', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_IP'] = $error_msg_text;
			}
		// Check banned IP
		if ($sabre_stealth['check_banned_IP'] == 'true') {
			$error_msg_text = __('Banned IP address.', 'sabre');
			$spammer_IP = $_SERVER['REMOTE_ADDR'];
			$reverse_IP = array_reverse(explode('.', $spammer_IP));
			$checked_domaine = implode('.', $reverse_IP) . '.' . 'zen.spamhaus.org';
			if ($checked_domaine != gethostbyname($checked_domaine)) {
				$errors->add('sabre_banIP', $error_head_text . $error_msg_text);
				$sabre_errors['sabre_banIP'] = $error_msg_text;
				}
			$checked_domaine = implode('.', $reverse_IP) . '.' . 'l1.spews.dnsbl.sorbs.net';
			if ($checked_domaine != gethostbyname($checked_domaine)) {
				$errors->add('sabre_banIP', $error_head_text . $error_msg_text);
				$sabre_errors['sabre_banIP'] = $error_msg_text;
				}
			$checked_domaine = implode('.', $reverse_IP) . '.' . 'list.dsbl.org';
			if ($checked_domaine != gethostbyname($checked_domaine)) {
				$errors->add('sabre_banIP', $error_head_text . $error_msg_text);
				$sabre_errors['sabre_banIP'] = $error_msg_text;
				}
			}
		// Check session time out
		if (strtotime($result->last_mod) + (int)$sabre_stealth['session_timeout'] < time()) {
			$error_msg_text = __('Session timed out.', 'sabre');
			$errors->add('sabre_timeout', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_timeout'] = $error_msg_text;
			}
		// Check excessive speed
		if (strtotime($result->last_mod) + (int)$sabre_stealth['speed_limit'] > time()) {
			$error_msg_text = __('Speedy Gonzales was here.', 'sabre');
			$errors->add('sabre_speed', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_speed'] = $error_msg_text;
			}
		// Check false fields
		$fakeField = "X" . md5($result->id . $sabre_stealth['magic_seed'] . $result->user_IP . strtotime($result->last_mod));
		if (!isset($_POST[$fakeField]) || !empty($_POST[$fakeField])) {
			$error_msg_text = __('Fake user.', 'sabre');
			$errors->add('sabre_fake_user', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_fake_user'] = $error_msg_text;
			}
		// Check Javascript capabilities
		if (empty($_POST['sabre_js_payload']) || empty($_POST['sabre_js_check1'])) {
			if ($sabre_stealth['js_support'] == 'true') {
				$error_msg_text = __('No Javascript capabilities.', 'sabre');
				$errors->add('sabre_js', $error_head_text . $error_msg_text);
				$sabre_errors['sabre_js'] = $error_msg_text;
				}
			}
		else {
			if ($_POST['sabre_js_check2'] != md5($_POST['sabre_js_payload'] . $_POST['sabre_js_check1'] . $sabre_stealth['magic_seed'])) {
				$error_msg_text = __('Fake Javascript capabilities.', 'sabre');
				$errors->add('sabre_fake_js', $error_head_text . $error_msg_text);
				$sabre_errors['sabre_fake_js'] = $error_msg_text;
				}
			}
		}
	
	if ($sabre_opt['user_pwd'] == 'true') {
		if(empty($_POST['user_pwd1']) || $_POST['user_pwd1'] == '' || empty($_POST['user_pwd2']) || $_POST['user_pwd2'] == ''){
			$error_msg_text = __('Missing password.', 'sabre');
			$errors->add('sabre_no_user_pwd', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_no_user_pwd'] = $error_msg_text;
		}elseif($_POST['user_pwd1'] !== $_POST['user_pwd2']){
			$error_msg_text = __('Mismatch between password fields.', 'sabre');
			$errors->add('sabre_mismatch_user_pwd', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_mismatch_user_pwd'] = $error_msg_text;
		}elseif(strlen($_POST['user_pwd1'])<6){
			$error_msg_text = __('Password length is less than 6 characters.', 'sabre');
			$errors->add('sabre_short_user_pwd', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_short_user_pwd'] = $error_msg_text;
		}
	}

	if ($sabre_opt['enable_policy'] == 'true') {
		if($_POST['policy'] != 'yes'){
			$error_msg_text = __('Policy not accepted.', 'sabre');
			$errors->add('sabre_no_policy', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_no_policy'] = $error_msg_text;
		}
	}

	if ($result->captcha != NULL) {
		$string = strtoupper($result->captcha);
		$stringlength = $sabre_captcha['stringlength'];
		$userstring = strtoupper($_POST['captcha']);

		if (($string <> $userstring) || (strlen($userstring) <> $stringlength)) {
			$error_msg_text = __('Invalid code.', 'sabre');
			$errors->add('sabre_captcha', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_captcha'] = $error_msg_text;
		}
	}

	if ($result->math != NULL) {
		$string = strtoupper($result->math);
		$stringlength = $sabre_captcha['stringlength'];
		$userstring = strtoupper($_POST['captcha']);

		if ($result->math <> $_POST['math']) {
			$error_msg_text = __('Invalid math result.', 'sabre');
			$errors->add('sabre_math', $error_head_text . $error_msg_text);
			$sabre_errors['sabre_math'] = $error_msg_text;
		}
	}

	if (!empty($sabre_errors)) {
		@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `user` = '" . $_POST['user_login'] . "', `email` = '" . $_POST['user_email'] . "', `msg` = '" . maybe_serialize($sabre_errors) . "', `last_mod` = NOW(), `status` = 'ko' WHERE `id` = " . (int)$_POST['sabre_id']);
		$sabre_opt['total_stopped'] += 1;
	}
	elseif ($sabre_confirm['enable_confirm'] != 'none') {
		@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `user` = '" . $_POST['user_login'] . "', `email` = '" . $_POST['user_email'] . "', `msg` = '', `last_mod` = NOW(), `status` = 'to confirm' WHERE `id` = " . (int)$_POST['sabre_id']);
		}
	else {
		@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `user` = '" . $_POST['user_login'] . "', `email` = '" . $_POST['user_email'] . "', `msg` = '', `last_mod` = NOW(), `status` = 'ok' WHERE `id` = " . (int)$_POST['sabre_id']);
		$sabre_opt['total_accepted'] += 1;
		}
	update_option('sabre_opt', $sabre_opt);
	}
return $errors;
}

/***********************************************************************/
/* Check the login header                                              */
/***********************************************************************/

function sabre_login_head() {
	global $error, $wpdb;

	$sabre_opt = get_option('sabre_opt');
	$sabre_confirm = get_option('sabre_confirm');

	$sabre_errors = array();
	$error_head_text = __('<strong>ERROR</strong>: ', 'sabre');

	if (isset($_REQUEST['sabre_confirm']) && !empty($_REQUEST['sabre_confirm'])) {
		if ($sabre_confirm['enable_confirm'] == 'user') {
			$result = $wpdb->get_row("SELECT * FROM `" . SABRE_TABLE . "` WHERE `md5_id` = '" . $_REQUEST['sabre_confirm'] . "'");
			if ((strtotime($result->last_mod) + (int)$sabre_confirm['period']*24*60*60 >= time()) && ('to confirm' == $result->status)) {
				$error = __('Registration confirmed. Happy blogging!', 'sabre');
				@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `last_mod` = NOW(), `status` = 'ok' WHERE `md5_id` = '" . $_REQUEST['sabre_confirm'] . "'");
				$sabre_opt['total_accepted'] += 1;
				update_option('sabre_opt', $sabre_opt);
				if ($sabre_confirm['mail_confirm'] == 'true')
					sabre_new_user_confirmation($result->user_id); 
				}
			else {
				if ('to confirm' == $result->status) {
					if ($sabre_confirm['delete_user'] == 'true') wp_delete_user($result->user_id);
					$error_msg_text = __('Exceeded period for confirmation of registration.', 'sabre');
					$error = $error_head_text . $error_msg_text;
					$sabre_errors['sabre_confirm'] = $error_msg_text;
					@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `msg` = '" . maybe_serialize($sabre_errors) . "', `last_mod` = NOW(), `status` = 'ko' WHERE `md5_id` = '" . $_REQUEST['sabre_confirm'] . "'");
					$sabre_opt['total_stopped'] += 1;
					update_option('sabre_opt', $sabre_opt);
					}
				else
					$error = $error_head_text . __('Unexpected confirmation of registration.', 'sabre');
				}
			}
		}
}

/***********************************************************************/
/* Check the login data                                                */
/***********************************************************************/

function sabre_check_login($user, $pass) {
	global $wpdb;

		$sabre_opt = get_option('sabre_opt');
		$sabre_confirm = get_option('sabre_confirm');
		if ($sabre_confirm['enable_confirm'] != 'none') {
			$sabre_errors = array();
			$error_head_text = __('<strong>ERROR</strong>: ', 'sabre');
			$cu = new WP_User($user->ID);
			
			if (!$cu->has_cap('edit_users')) {
				$result = $wpdb->get_row("SELECT * FROM `" . SABRE_TABLE . "` WHERE `user_id` = " . (int)$user->ID);
				if ('ok' != $result->status) {
					if ('to confirm' == $result->status) {
						if ($sabre_confirm['enable_confirm'] == 'user') {
							if (strtotime($result->last_mod) + (int)$sabre_confirm['period']*24*60*60 < time()) {
								$error_msg_text = __('Exceeded period for confirmation of registration.', 'sabre');
								$sabre_errors['sabre_login'] = $error_msg_text;
								@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `msg` = '" . maybe_serialize($sabre_errors) . "', `last_mod` = NOW(), `status` = 'ko' WHERE `id` = " . (int)$result->id);
								$sabre_opt['total_stopped'] += 1;
								update_option('sabre_opt', $sabre_opt);
								return new WP_Error('sabre_login', $error_head_text . $error_msg_text);
								}
							elseif ($sabre_confirm['no_entry'] == 'true') {
								$error_msg_text = __('Confirmation pending. See registration e-mail.', 'sabre');
								$sabre_errors['sabre_login'] = $error_msg_text;
								return new WP_Error('sabre_login', $error_head_text . $error_msg_text);
								}
							}
						else {
							$error_msg_text = __('Registration not yet validated by blog admin. Wait for confirmation e-mail.', 'sabre');
							$sabre_errors['sabre_login'] = $error_msg_text;
							return new WP_Error('sabre_login', $error_head_text . $error_msg_text);
							}
						}
					else {
						$error_msg_text = __('Invalid registration status.', 'sabre');
						$sabre_errors['sabre_login'] = $error_msg_text;
						return new WP_Error('sabre_login', $error_head_text . $error_msg_text);
						}
					}
				}
			}
		return $user;
}


/***********************************************************************/
/* Redefine user notification function                                 */
/***********************************************************************/

if ( !function_exists('wp_new_user_notification') ) :
function wp_new_user_notification($user_id, $plaintext_pass = '') {
	global $wpdb;

	$user = new WP_User($user_id);

	$user_login = stripslashes($user->user_login);
	$user_email = stripslashes($user->user_email);

	$message  = sprintf(__('New user registration on your blog %s:', 'sabre'), get_option('blogname')) . "\r\n\r\n";
	$message .= sprintf(__('Username: %s', 'sabre'), $user_login) . "\r\n\r\n";
	$message .= sprintf(__('E-mail: %s', 'sabre'), $user_email) . "\r\n";

	@wp_mail(get_option('admin_email'), sprintf(__('[%s] New User Registration', 'sabre'), get_option('blogname')), $message);

	if ( empty($plaintext_pass) )
		return;

	$sabre_confirm = get_option('sabre_confirm');
	$sabre_opt = get_option('sabre_opt');

	if ($sabre_opt['user_pwd'] == 'true') {
		$plaintext_pass = $_POST['user_pwd1'];
		wp_set_password($plaintext_pass, $user_id);
		}

	$message  = sprintf(__('Thank you for registrating on %s', 'sabre'), get_option('blogname')) . "\r\n\r\n";
	$message .= sprintf(__('Username: %s', 'sabre'), $user_login) . "\r\n";
	$message .= sprintf(__('Password: %s', 'sabre'), $plaintext_pass) . "\r\n\r\n";
	if ($sabre_confirm['enable_confirm'] == 'user') {
		$message .= sprintf(__('You must confirm your registration within %s days by following the link below', 'sabre'), $sabre_confirm['period']) . "\r\n\r\n";
		$message .= get_option('siteurl') . "/wp-login.php?sabre_confirm=" . md5($_POST['sabre_id']) . "\r\n";
	}
	elseif ($sabre_confirm['enable_confirm'] == 'admin') {
		$message .= __('Your registration has to be validated by the administrator before you can sign on the blog. You will be advised by e-mail upon completion.', 'sabre') . "\r\n\r\n";
		$message .= get_option('siteurl') . "/wp-login.php\r\n";
	}
	else {
		$message .= get_option('siteurl') . "/wp-login.php\r\n";
	}

	wp_mail($user_email, sprintf(__('[%s] Your username and password', 'sabre'), get_option('blogname')), $message);

	@$wpdb->query("UPDATE `" . SABRE_TABLE . "` SET `user_id` = '" . $user_id . "', `md5_id` = '" . md5($_POST['sabre_id']) . "' WHERE `id` = " . (int)$_POST['sabre_id']);

}
endif;

include_once(dirname(__FILE__) . "/sabre_define.php");
include_once(dirname(__FILE__) . "/sabre_misc.php");
require_once(ABSPATH . 'wp-admin/includes/user.php');

/***********************************************************************/
/* Let's go for the party !                                            */
/***********************************************************************/

add_action('init', 'sabre_init');
add_action('login_head', 'sabre_login_css');
add_action('admin_head', 'sabre_css');
add_action('admin_menu', 'sabre_options');
add_action('register_form', 'sabre_change_registration_form');
add_filter('registration_errors', 'sabre_check_entry');
add_action('login_head', 'sabre_login_head');
add_filter('wp_authenticate_user', 'sabre_check_login', 10, 2);
register_activation_hook(__FILE__, 'sabre_activate');
register_deactivation_hook(__FILE__, 'sabre_deactivate');


?>